/*  XRoar - a Dragon/Tandy Coco emulator
 *  Copyright (C) 2003-2004  Ciaran Anscomb
 *
 *  See LICENCE for redistribution conditions. */

#ifndef __VIDEO_H__
#define __VIDEO_H__

#ifdef GP32
# include "video_gp32.h"
#else
# include "video_sdl.h"
#endif

#include "types.h"

void video_init(void);
void video_clear_screen(PIXEL colour);
void video_fillrect(Uint32 x, Uint32 y, Uint32 w, Uint32 h, PIXEL colour);
void video_blit_bothbufs(Uint32 dest, PIXEL *src, Uint32 width, Uint32 height);
void video_blit(Uint32 dest, PIXEL *src, Uint32 width, Uint32 height);
void video_blit_static(int x, int y, PIXEL *src, int w, int h);
void video_backup(PIXEL *base);
void video_restore(PIXEL *base);

#endif  /* __VIDEO_H__ */
